Code

Merge git://repo.or.cz/git-gui
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 # Keep the original TERM for say_color
7 ORIGINAL_TERM=$TERM
9 # For repeatability, reset the environment to known value.
10 LANG=C
11 LC_ALL=C
12 PAGER=cat
13 TZ=UTC
14 TERM=dumb
15 export LANG LC_ALL PAGER TERM TZ
16 EDITOR=:
17 VISUAL=:
18 unset GIT_EDITOR
19 unset AUTHOR_DATE
20 unset AUTHOR_EMAIL
21 unset AUTHOR_NAME
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
24 unset EMAIL
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26 unset GIT_AUTHOR_DATE
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
32 unset GIT_DIFF_OPTS
33 unset GIT_DIR
34 unset GIT_WORK_TREE
35 unset GIT_EXTERNAL_DIFF
36 unset GIT_INDEX_FILE
37 unset GIT_OBJECT_DIRECTORY
38 unset SHA1_FILE_DIRECTORIES
39 unset SHA1_FILE_DIRECTORY
40 GIT_MERGE_VERBOSITY=5
41 export GIT_MERGE_VERBOSITY
42 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
44 export EDITOR VISUAL
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
48 unset CDPATH
50 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
51         1|2|true)
52                 echo "* warning: Some tests will not work if GIT_TRACE" \
53                         "is set as to trace on STDERR ! *"
54                 echo "* warning: Please set GIT_TRACE to something" \
55                         "other than 1, 2 or true ! *"
56                 ;;
57 esac
59 # Each test should start with something like this, after copyright notices:
60 #
61 # test_description='Description of this test...
62 # This test checks if command xyzzy does the right thing...
63 # '
64 # . ./test-lib.sh
65 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
66                 TERM=$ORIGINAL_TERM &&
67                 export TERM &&
68                 [ -t 1 ] &&
69                 tput bold >/dev/null 2>&1 &&
70                 tput setaf 1 >/dev/null 2>&1 &&
71                 tput sgr0 >/dev/null 2>&1
72         ) &&
73         color=t
75 while test "$#" -ne 0
76 do
77         case "$1" in
78         -d|--d|--de|--deb|--debu|--debug)
79                 debug=t; shift ;;
80         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
81                 immediate=t; shift ;;
82         -h|--h|--he|--hel|--help)
83                 help=t; shift ;;
84         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
85                 verbose=t; shift ;;
86         -q|--q|--qu|--qui|--quie|--quiet)
87                 quiet=t; shift ;;
88         --no-color)
89                 color=; shift ;;
90         --no-python)
91                 # noop now...
92                 shift ;;
93         *)
94                 break ;;
95         esac
96 done
98 if test -n "$color"; then
99         say_color () {
100                 (
101                 TERM=$ORIGINAL_TERM
102                 export TERM
103                 case "$1" in
104                         error) tput bold; tput setaf 1;; # bold red
105                         skip)  tput bold; tput setaf 2;; # bold green
106                         pass)  tput setaf 2;;            # green
107                         info)  tput setaf 3;;            # brown
108                         *) test -n "$quiet" && return;;
109                 esac
110                 shift
111                 echo "* $*"
112                 tput sgr0
113                 )
114         }
115 else
116         say_color() {
117                 test -z "$1" && test -n "$quiet" && return
118                 shift
119                 echo "* $*"
120         }
121 fi
123 error () {
124         say_color error "error: $*"
125         trap - exit
126         exit 1
129 say () {
130         say_color info "$*"
133 test "${test_description}" != "" ||
134 error "Test script did not set test_description."
136 if test "$help" = "t"
137 then
138         echo "$test_description"
139         exit 0
140 fi
142 exec 5>&1
143 if test "$verbose" = "t"
144 then
145         exec 4>&2 3>&1
146 else
147         exec 4>/dev/null 3>/dev/null
148 fi
150 test_failure=0
151 test_count=0
152 test_fixed=0
153 test_broken=0
155 die () {
156         echo >&5 "FATAL: Unexpected exit with code $?"
157         exit 1
160 trap 'die' exit
162 test_tick () {
163         if test -z "${test_tick+set}"
164         then
165                 test_tick=1112911993
166         else
167                 test_tick=$(($test_tick + 60))
168         fi
169         GIT_COMMITTER_DATE="$test_tick -0700"
170         GIT_AUTHOR_DATE="$test_tick -0700"
171         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
174 # You are not expected to call test_ok_ and test_failure_ directly, use
175 # the text_expect_* functions instead.
177 test_ok_ () {
178         test_count=$(expr "$test_count" + 1)
179         say_color "" "  ok $test_count: $@"
182 test_failure_ () {
183         test_count=$(expr "$test_count" + 1)
184         test_failure=$(expr "$test_failure" + 1);
185         say_color error "FAIL $test_count: $1"
186         shift
187         echo "$@" | sed -e 's/^/        /'
188         test "$immediate" = "" || { trap - exit; exit 1; }
191 test_known_broken_ok_ () {
192         test_count=$(expr "$test_count" + 1)
193         test_fixed=$(($test_fixed+1))
194         say_color "" "  FIXED $test_count: $@"
197 test_known_broken_failure_ () {
198         test_count=$(expr "$test_count" + 1)
199         test_broken=$(($test_broken+1))
200         say_color skip "  still broken $test_count: $@"
203 test_debug () {
204         test "$debug" = "" || eval "$1"
207 test_run_ () {
208         eval >&3 2>&4 "$1"
209         eval_ret="$?"
210         return 0
213 test_skip () {
214         this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
215         this_test="$this_test.$(expr "$test_count" + 1)"
216         to_skip=
217         for skp in $GIT_SKIP_TESTS
218         do
219                 case "$this_test" in
220                 $skp)
221                         to_skip=t
222                 esac
223         done
224         case "$to_skip" in
225         t)
226                 say_color skip >&3 "skipping test: $@"
227                 test_count=$(expr "$test_count" + 1)
228                 say_color skip "skip $test_count: $1"
229                 : true
230                 ;;
231         *)
232                 false
233                 ;;
234         esac
237 test_expect_failure () {
238         test "$#" = 2 ||
239         error "bug in the test script: not 2 parameters to test-expect-failure"
240         if ! test_skip "$@"
241         then
242                 say >&3 "checking known breakage: $2"
243                 test_run_ "$2"
244                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
245                 then
246                         test_known_broken_ok_ "$1"
247                 else
248                     test_known_broken_failure_ "$1"
249                 fi
250         fi
251         echo >&3 ""
254 test_expect_success () {
255         test "$#" = 2 ||
256         error "bug in the test script: not 2 parameters to test-expect-success"
257         if ! test_skip "$@"
258         then
259                 say >&3 "expecting success: $2"
260                 test_run_ "$2"
261                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
262                 then
263                         test_ok_ "$1"
264                 else
265                         test_failure_ "$@"
266                 fi
267         fi
268         echo >&3 ""
271 test_expect_code () {
272         test "$#" = 3 ||
273         error "bug in the test script: not 3 parameters to test-expect-code"
274         if ! test_skip "$@"
275         then
276                 say >&3 "expecting exit code $1: $3"
277                 test_run_ "$3"
278                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
279                 then
280                         test_ok_ "$2"
281                 else
282                         test_failure_ "$@"
283                 fi
284         fi
285         echo >&3 ""
288 # This is not among top-level (test_expect_success | test_expect_failure)
289 # but is a prefix that can be used in the test script, like:
291 #       test_expect_success 'complain and die' '
292 #           do something &&
293 #           do something else &&
294 #           test_must_fail git checkout ../outerspace
295 #       '
297 # Writing this as "! git checkout ../outerspace" is wrong, because
298 # the failure could be due to a segv.  We want a controlled failure.
300 test_must_fail () {
301         "$@"
302         test $? -gt 0 -a $? -le 128
305 # Most tests can use the created repository, but some may need to create more.
306 # Usage: test_create_repo <directory>
307 test_create_repo () {
308         test "$#" = 1 ||
309         error "bug in the test script: not 1 parameter to test-create-repo"
310         owd=`pwd`
311         repo="$1"
312         mkdir "$repo"
313         cd "$repo" || error "Cannot setup test environment"
314         "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
315         error "cannot run git init -- have you built things yet?"
316         mv .git/hooks .git/hooks-disabled
317         cd "$owd"
320 test_done () {
321         trap - exit
323         if test "$test_fixed" != 0
324         then
325                 say_color pass "fixed $test_fixed known breakage(s)"
326         fi
327         if test "$test_broken" != 0
328         then
329                 say_color error "still have $test_broken known breakage(s)"
330                 msg="remaining $(($test_count-$test_broken)) test(s)"
331         else
332                 msg="$test_count test(s)"
333         fi
334         case "$test_failure" in
335         0)
336                 # We could:
337                 # cd .. && rm -fr trash
338                 # but that means we forbid any tests that use their own
339                 # subdirectory from calling test_done without coming back
340                 # to where they started from.
341                 # The Makefile provided will clean this test area so
342                 # we will leave things as they are.
344                 say_color pass "passed all $msg"
345                 exit 0 ;;
347         *)
348                 say_color error "failed $test_failure among $msg"
349                 exit 1 ;;
351         esac
354 # Test the binaries we have just built.  The tests are kept in
355 # t/ subdirectory and are run in trash subdirectory.
356 PATH=$(pwd)/..:$PATH
357 GIT_EXEC_PATH=$(pwd)/..
358 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
359 unset GIT_CONFIG
360 unset GIT_CONFIG_LOCAL
361 GIT_CONFIG_NOSYSTEM=1
362 GIT_CONFIG_NOGLOBAL=1
363 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
365 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
366 export GITPERLLIB
367 test -d ../templates/blt || {
368         error "You haven't built things yet, have you?"
371 if ! test -x ../test-chmtime; then
372         echo >&2 'You need to build test-chmtime:'
373         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
374         exit 1
375 fi
377 . ../GIT-BUILD-OPTIONS
379 # Test repository
380 test=trash
381 rm -fr "$test"
382 test_create_repo $test
383 cd "$test"
385 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
386 for skp in $GIT_SKIP_TESTS
387 do
388         to_skip=
389         for skp in $GIT_SKIP_TESTS
390         do
391                 case "$this_test" in
392                 $skp)
393                         to_skip=t
394                 esac
395         done
396         case "$to_skip" in
397         t)
398                 say_color skip >&3 "skipping test $this_test altogether"
399                 say_color skip "skip all tests in $this_test"
400                 test_done
401         esac
402 done